var site = {},
    user = {},
    count = 0,
    done = false,
    $message = $("#message"),
    $progress = $(".progress"),
    $menu = $("#pinion-menu"),
    $list = $("#pinion-install-list"),
    $installListItems = $list.children(),
    install = function() {
        if(count < modules.length) {
            var module = modules[count],
                loader = new pinion.Loader("darkblue-30px", 30),
                outerAjaxCounter = 0,
                innerAjaxCounter = 0,
                outerAjax = function() {
                    outerAjaxCounter++;
                    if(outerAjaxCounter < 50) {
                        $.ajax({
                            url: "install.php",
                            type: "post",
                            dataType: "html",
                            data: {install: module},
                            success: innerAjax,
                            error: function() {
                                setTimeout(outerAjax, 500, module, loader);
                            }
                        });
                    } else {
                        innerAjax();
                    }
                },
                innerAjax = function() {
                    innerAjaxCounter++;
                    if(innerAjaxCounter < 50) {
                        $.ajax({
                            url: "index.php",
                            type: "post",
                            dataType: "json",
                            data: user,
                            success: innerAjaxCallback,
                            error: function() {
                                setTimeout(innerAjax, 500);
                            }
                        });
                    } else {
                        innerAjaxCallback();
                        $installListItems
                            .eq(count-1)
                                .removeClass("installed")
                                .addClass("notInstalled");
                    }
                },
                innerAjaxCallback = function() {
                    loader.remove();
                    $installListItems
                        .eq(count)
                            .removeClass("installNow")
                            .addClass("installed")
                            //.appendTo($list); // move the newest to the top

                    count++;
                    $progress.animate({
                        width: count/modules.length*100+"%"
                    }, 300);
                    install();
                };

            $("#pinion-install-module").html("install module <b>"+module+"</b> ("+(count+1)+"/"+modules.length+")");
            $installListItems
                .eq(count)
                    .removeClass("notInstalled")
                    .addClass("installNow")
                    .children(".pinion-module-status")
                        .append(loader.$element);


            outerAjax();
        } else {
            $("#pinion-install-module").html("<b>"+modules.length+" modules installed</b>");
            if(user.admin_email != "") {
                // send mail to user
                $.post("install.php", $.extend({sendmail: true}, user));
            }
            setTimeout(function() {
                $("#pinion-install-page-install").hide();
                $menu.children().removeClass("active").filter("[data-id='pinion-install-page-complete']").addClass("active");
                $("#pinion-install-page-complete").show();
                done = true;
            }, 1500);
        }
    };

$(".pinion-previousStep").click(function(event) {
    var $activeMenuChild = $menu.children(".active");
    $("#"+$activeMenuChild.attr("data-id")).hide();
    $activeMenuChild = $activeMenuChild.removeClass("active").prev().addClass("active");
    $("#"+$activeMenuChild.attr("data-id")).show();

    event.stopPropagation();
    return false;
});

$menu.children().click(function() {
    var $activeMenuChild = $menu.children(".active"),
        activeIndex = $activeMenuChild.index(),
        $this = $(this),
        index = $this.index();
        
    if(activeIndex < 3 && index < activeIndex) {
        $("#"+$activeMenuChild.attr("data-id")).hide();
        $activeMenuChild.removeClass("active");
        $activeMenuChild = $this.addClass("active");
        $("#"+$activeMenuChild.attr("data-id")).show();
    }
    return false;
});

$("#userForm").submit(function() {
    var $this = $(this);
    user = {
        admin_firstname: $.trim($this.find("[name=firstname]").val()),
        admin_lastname: $.trim($this.find("[name=lastname]").val()),
        admin_email: $.trim($this.find("[name=email]").val()),
        admin_language: $this.find("[name=language]").val(),
        admin_username: $.trim($this.find("[name=username]").val()),
        admin_password: $.trim($this.find("[name=password]").val())
    };
    
    if(user.admin_firstname == "") {
        var msgs = {
            en: "Please type in your firstname",
            de: "Bitte gib deinen Vornamen ein"
        };
        $message
            .text(msgs[currentLang])
            .show();
    } else if(user.admin_lastname == "") {
        var msgs = {
            en: "Please type in your lastname",
            de: "Bitte gib deinen Nachnamen ein"
        };
        $message
            .text(msgs[currentLang])
            .show();
    } else if(user.admin_email == "") {
        var msgs = {
            en: "Please type in your email-address",
            de: "Bitte gib deine Email-Adresse ein"
        };
        $message
            .text(msgs[currentLang])
            .show();
    } else if(!/^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/.test(user.admin_email)) {
        var msgs = {
            en: "Please type in a valid email-address",
            de: "Bitte gib eine gültige Email-Adresse ein"
        };
        $message
            .text(msgs[currentLang])
            .show();
    } else if(user.admin_username == "") {
        var msgs = {
            en: "Please type in your username",
            de: "Bitte gib deinen Benutzernamen ein"
        };
        $message
            .text(msgs[currentLang])
            .show();
    } else if(user.admin_password == "") {
        var msgs = {
            en: "Please type in your password",
            de: "Bitte gib dein Passwort ein"
        };
        $message
            .text(msgs[currentLang])
            .show();
    } else if($.trim($this.find("[name=confirmpassword]").val()) == "") {
        var msgs = {
            en: "Please confirm your password",
            de: "Bitte bestätige dein Passwort"
        };
        $message
            .text(msgs[currentLang])
            .show();
    } else if($.trim($this.find("[name=confirmpassword]").val()) != user.admin_password) {
        var msgs = {
            en: "The confirmation of the password is not correct",
            de: "Die Bestätigung des Passworts war nicht korrekt"
        };
        $message
            .text(msgs[currentLang])
            .show();
    } else {
        $message.hide();
        $("#pinion-install-page-user").hide();
        $menu.children().removeClass("active").filter("[data-id='pinion-install-page-site']").addClass("active");
        $("#pinion-install-page-site").show();
    }
    
    return false;
});

$("#siteForm").submit(function() {
    var $this = $(this);
    site = {
        sitename: $.trim($this.find("[name=sitename]").val()),
        timezone: $this.find("[name=timezone]").val(),
        language: $this.find("[name=language]").val(),
        languages: $this.find("[name=languages]").val()
    };
    if(site.sitename == "") {
        var msgs = {
            en: "Please type in the name of your site",
            de: "Bitte gib den Namen der Seite ein"
        };
        $message
            .text(msgs[currentLang])
            .show();
    } else {
        $message.hide();
        $("#pinion-install-page-site").hide();
        $menu.children().removeClass("active").filter("[data-id='pinion-install-page-database']").addClass("active");
        $("#pinion-install-page-database").show();
        
        // make an ajax to write the info.ini for the template
        $.ajax({
            url: "install.php",
            type: "post",
            data: {
                backgroundColor: $this.find("[name=pagecolor]").val(),
                headerColor: $this.find("[name=headercolor]").val(),
                footerColor: $this.find("[name=footercolor]").val(),
                headerTextColor: $this.find("[name=headertextcolor]").val(),
                footerTextColor: $this.find("[name=footertextcolor]").val(),
            }
        });
    }
    
    return false;
});

$("#databaseForm").submit(function() {
    var $this = $(this),
        database = $.trim($this.find("[name=database]").val()),
        host = $.trim($this.find("[name=host]").val());
    
    if(database == "") {
        var msgs = {
            en: "Please type in the name of the database",
            de: "Bitte gib den Namen der Datenbank ein"
        };
        $message
            .text(msgs[currentLang])
            .show();
    } else if(host == "") {
        var msgs = {
            en: "Please type in the host of the database",
            de: "Bitte gib den Host der Datenbank ein"
        };
        $message
            .text(msgs[currentLang])
            .show();
    } else {
        $message.hide();
        var outerAjaxCounter = 0,
            innerAjaxCounter = 0,
            outerAjax = function() {
                outerAjaxCounter++;
                if(outerAjaxCounter < 50) {
                    $.ajax({
                        url: "index.php?logout", // log out the user
                        type: "post",
                        dataType: "json",
                        data: $.extend(site, {
                            database:    database,
                            username:    $.trim($this.find("[name=username]").val()),
                            password:    $.trim($this.find("[name=password]").val()),
                            host:        host,
                            tableprefix: $.trim($this.find("[name=tableprefix]").val())
                        }),
                        success: function(data) {
                            if(data.error === undefined) {
                                $message.hide();
                                $("#pinion-install-page-database").hide();
                                $menu.children().removeClass("active").filter("[data-id='pinion-install-page-install']").addClass("active");
                                $("#pinion-install-page-install").show();
                                innerAjax();
                            } else {
                                $message
                                    .text(data.error[currentLang])
                                    .show();
                            }
                        },
                        error: function() {
                            setTimeout(outerAjax, 500);
                        }
                    });
                } else {
                    $("#pinion-install-page-database").hide();
                    $menu.children().removeClass("active").filter("[data-id='pinion-install-page-install']").addClass("active");
                    $("#pinion-install-page-install").show();
                    innerAjax();
                }
            },
            innerAjax = function() {
                innerAjaxCounter++;
                if(innerAjaxCounter < 10) {
                    $.ajax({
                        url: "index.php",
                        type: "post",
                        success: install,
                        error: innerAjax
                    });
                } else {
                    setTimeout(install, 500);
                }
            };

        // create database.ini
        outerAjax();
    }
    
    return false;
});



$("#backendLink").click(function() {
    $.post("index.php", {username: user.admin_username, password: user.admin_password}, function() {
        window.location.reload();
    });
    return false;
});

$(".pinion-install-colorpicker").each(function() {
    var $this = $(this);
    $this.ColorPicker({
	color: $this.val(),
	onShow: function(colpkr) {
            $(colpkr).fadeIn(500);
            return false;
	},
	onHide: function(colpkr) {
            $(colpkr).fadeOut(500);
            return false;
	},
	onChange: function(hsb, hex, rgb) {
            $this
                .val("#"+hex)
                .css("background", "#"+hex);
	}
    }).css("background", $this.val());
});

// TRANSLATION
var currentLang = "en";
var translate = (function() {
    
    var initialized = false,
        $elements = null;
    
    return function(lang) {
        if(!initialized) {
            if(lang != "en") {
                $elements = $(".translated");
                $elements.each(function() {
                    var $this = $(this);
                    $this.attr("data-lang-en", $this.html());
                    $this.html($this.attr("data-lang-"+lang));
                });
                currentLang = lang;
                initialized = true;
            }
        } else if(currentLang != lang) {
            $elements.each(function() {
                var $this = $(this);
                $this.html($this.attr("data-lang-"+lang));
            });
            currentLang = lang;
        }
    };
}());

$("#pinion-start-languages li").click(function() {
    translate($(this).attr("data-lang"));
    $("#pinion-start").fadeOut(300);
});

$("#language-link").click(function() {
    $("#pinion-start").fadeIn(300);
});