<?php
/**
 * Module Video
 *
 * @author Friedolin Förder 
 */
namespace modules\tagcloud;

use \pinion\modules\Module;
use \pinion\modules\FrontendModule;
use \pinion\events\Event;
use \pinion\general\TemplateBuilder;

class Tagcloud extends FrontendModule {
    
    public function install() {
        $this->data
            ->createDataStorage($this->name, array(
                "count" => array("type" => "int")
            ));    
    }
    
    public function defineBackend() {
        parent::defineBackend();
        
        // add backend elements with $this->framework...
            
    }
    
        
    public function add(Event $event) {
        
        // the new data
        $data = array();
        
        
        
        // fill the data with information from the event...
        $data["count"] = $event->getInfo("count", 50);
        
        
        // create the data storage
        $tagcloud = $this->data->create($this->name, $data);
        
        
        // add a success message
        $this->response->addSuccess($this, $this->translate("%s added", "<b>".$this->translate($this->information["title"])."</b>"));
        
        // call standard procedure
        $this->_add($event, $tagcloud);
    }
    
    
    public function edit(Event $event) {
        
        // get the id from the event
        $id = $event->getInfo("id");
        
        
        // get the data storage
        $tagcloud = $this->data->find($this->name, $id);
        
        
        
        // update the data storage...
        $tagcloud->count = $event->getInfo("count");
        
        
        // save the data storage
        $tagcloud->save();
        
        
        // add a success message
        $this->response->addSuccess($this, $this->translate("%s edited", "<b>".$this->translate($this->information["title"])."</b>"));
        
        // call standard procedure
        $this->_edit($event, $tagcloud);
    }
    
    public function defineEditor(Event $event) {
        parent::defineEditor($event);
        
        $settings = $event->getInfo("settings");
        
        $this->framework
            ->key("elements")
                ->input("Slider", array(
                    "label" => "count",
                    "min" => 5,
                    "max" => 250,
                    "value" => $settings["_isNew"] ? 50 : $settings["data"]["count"],
                    "events" => $settings["events"]
                ));
    }
    
    public function setFrontendVars($data) {
        return $this->module("tags")->getInformationAboutTags($data->count);
    }
}


?>