<?php
###PHP_MODULE_INFORMATION###

namespace modules\todo;

use \pinion\modules\Module;
use \pinion\modules\FrontendModule;
use \pinion\events\Event;
use \pinion\general\TemplateBuilder;

class Todo extends FrontendModule {
    
    
    public function install() {
        $this->data
            ->createDataStorage("todo", array(
                "text" => array("type" => "text")
            ));
    }
    
    public function getResources() {
        
        $resources = parent::getResources();
        
        unset(
            $resources[array_search("change visibility", $resources)],
            $resources[array_search("change visibility of own", $resources)]
        );
        
        return $resources;
    }
    
    public function add(Event $event) {
        
        // the new data
        $data = array();
        
        
        
        // fill the data with information from the event...
        $data["text"] = $event->getInfo("text");
        
        
        // create the data storage
        $todo = $this->data->create($this->name, $data);
        
        // add a success message
        $this->response->addSuccess($this, $this->translate("%s added", "<b>".$this->translate($this->information["title"])."</b>"));
        
        // call standard procedure
        $this->_add($event, $todo);
    }
    
    
    public function edit(Event $event) {
        
        // get the id from the event
        $id = $event->getInfo("id");
        
        
        // get the data storage
        $todo = $this->data->find($this->name, $id);
        
        
        
        // update the data storage...
        $todo->text = $event->getInfo("text");
        
        
        // save the data storage
        $todo->save();
        
        
        // add a success message
        $this->response->addSuccess($this, $this->translate("%s edited", "<b>".$this->translate($this->information["title"])."</b>"));
        
        // call standard procedure
        $this->_edit($event, $todo);
    }
    
    public function defineEditor(Event $event) {
        parent::defineEditor($event);
        
        $settings = $event->getInfo("settings");
        
        $this->framework
            ->key("elements")
                ->input("Editor", array(
                    "value" => $settings["_isNew"] ? "" : $settings["data"]["text"],
                    "CKOptions" => array(
                        "toolbar" => "Frontend"
                    ),
                    "infoKey" => "text",
                    "events" => $settings["events"]
                ));
        
    }
        
}


?>